catcdc/apps/vote/urls.py
from django.urls import path

from .views import ResultsView, SubmissionView, CatsView, VoteView

app_name = "vote"

urlpatterns = [
    path("vote", VoteView.as_view(), name="vote"),
    path("results", ResultsView.as_view(), name="results"),
    path("submit", SubmissionView.as_view(), name="submission"),
    path("cats", CatsView.as_view(), name="cats"),
]

catcdc/urls.py
from django.contrib import admin
from django.urls import include, path
from django.shortcuts import render

urlpatterns = [
    path("admin/", admin.site.urls),
    path("accounts/", include("social_django.urls", namespace="social")),
    path("", include("landing_page.urls")),
    path("vote/", include("vote.urls", namespace="vote")),
    path("bulk_user_add/", include("bulk_user_add.urls")),
]


# pylint:disable=unused-argument
def page_not_found(request, exception):
    return render(request, "404.html")


# pylint:disable=invalid-name
handler404 = "urls.page_not_found"

catcdc/apps/vote/models.py
from django.db import models
from django.conf import settings


class Submission(models.Model):
    # pylint:disable=line-too-long
    submitter = models.OneToOneField(
        settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name="submitter"
    )
    cat_name = models.CharField(max_length=255)
    presentation = models.TextField(max_length=500)
    image_1 = models.ImageField()
    image_2 = models.ImageField()
    image_3 = models.ImageField()
    image_4 = models.ImageField()
    image_5 = models.ImageField()

    def __str__(self):
        return f"{self.submitter.username}: {self.cat_name}"


class Vote(models.Model):
    # pylint:disable=line-too-long
    voter = models.ForeignKey(
        settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name="voter"
    )
    submission = models.ForeignKey(
        Submission, on_delete=models.CASCADE, related_name="submission"
    )
    weight = models.IntegerField()

    # pylint:disable=line-too-long
    def __str__(self):
        return f"{self.voter.username}: {self.weight} - {self.submission.cat_name}"

catcdc/apps/vote/forms.py
from django import forms

from .models import Submission


class SubmissionForm(forms.ModelForm):
    class Meta:
        model = Submission
        fields = [
            "cat_name",
            "presentation",
            "image_1",
            "image_2",
            "image_3",
            "image_4",
            "image_5",
        ]


class VoteForm(forms.Form):
    choices = forms.CharField(max_length=255, widget=forms.HiddenInput())

catcdc/apps/vote/views/cats.py
from random import shuffle

from django.shortcuts import render
from django.views.generic import TemplateView

from common.util import (
    is_submission_started,
    is_submission_ended,
    is_vote_started,
    is_vote_ended,
)

from ..models import Submission


class CatsView(TemplateView):
    template_name = "vote/cats.html"

    def get(self, request, *args, **kwargs):
        context = {
            "is_submission_started": is_submission_started(),
            "is_submission_ended": is_submission_ended(),
            "is_vote_started": is_vote_started(),
            "is_vote_ended": is_vote_ended(),
        }

        cats = Submission.objects.all()
        cats = list(cats)
        shuffle(cats)
        context["cats"] = cats

        return render(request, self.template_name, context)

catcdc/apps/vote/views/results.py
from django.shortcuts import render
from django.views.generic import TemplateView

from common.util import (
    is_submission_started,
    is_submission_ended,
    is_vote_started,
    is_vote_ended,
)

from ..models import Submission, Vote


class ResultsView(TemplateView):
    template_name = "vote/results.html"

    def get(self, request, *args, **kwargs):
        context = {
            "is_submission_started": is_submission_started(),
            "is_submission_ended": is_submission_ended(),
            "is_vote_started": is_vote_started(),
            "is_vote_ended": is_vote_ended(),
        }

        votes = Vote.objects.all()
        nb_submissions = Submission.objects.count()

        results = []
        for submission in Submission.objects.all():
            submission_votes = votes.filter(submission=submission)
            score = 0
            top_vote = 0

            for vote in submission_votes:
                score += vote.weight
                if vote.weight == nb_submissions:
                    top_vote += 1
            results.append([submission, score, top_vote])
        results.sort(key=lambda s: (s[1]), reverse=True)
        context["results"] = results

        context["total_nb_votes"] = len(votes.distinct("voter"))

        return render(request, self.template_name, context)

catcdc/apps/vote/views/submission.py
from django.conf import settings
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.shortcuts import render, redirect
from django.views.generic import TemplateView

from common.util import is_submission_started, is_submission_ended

from ..models import Submission
from ..forms import SubmissionForm


class SubmissionView(PermissionRequiredMixin, TemplateView):
    permission_required = ("vote.add_submission", "vote.change_submission")
    template_name = "vote/submission.html"

    # pylint:disable=unused-argument
    def get(self, request, *args, **kwargs):
        context = {
            "is_submission_started": is_submission_started(),
            "is_submission_ended": is_submission_ended(),
            "submission_start": settings.SUBMISSION_START.isoformat(),
            "submission_end": settings.SUBMISSION_END.isoformat(),
        }
        current_submission = Submission.objects.filter(submitter=request.user)
        if current_submission.exists():
            form = SubmissionForm(instance=current_submission.first())
        else:
            form = SubmissionForm()
        context["form"] = form
        return render(request, self.template_name, context)

    # pylint:disable=unused-argument,line-too-long
    def post(self, request, *args, **kwargs):
        current_submission = Submission.objects.filter(submitter=request.user)
        if current_submission.exists():
            form = SubmissionForm(
                request.POST, request.FILES, instance=current_submission.first()
            )
        else:
            form = SubmissionForm(request.POST, request.FILES)

        if form.is_valid() and is_submission_started() and not is_submission_ended():
            submission = form.save(commit=False)
            submission.submitter = request.user
            submission.save()
            form.save_m2m()
            return redirect("vote:results")

        context = {
            "is_submission_started": is_submission_started(),
            "is_submission_ended": is_submission_ended(),
            "submission_start": settings.SUBMISSION_START.isoformat(),
            "submission_end": settings.SUBMISSION_END.isoformat(),
        }
        context["form"] = form
        return render(request, self.template_name, context)

catcdc/apps/vote/views/vote.py
from random import shuffle

from django.conf import settings
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.shortcuts import render, redirect
from django.views.generic import TemplateView

from common.util import is_vote_started, is_vote_ended

from ..models import Submission, Vote
from ..forms import VoteForm


class VoteView(PermissionRequiredMixin, TemplateView):
    permission_required = ("vote.add_vote", "vote.change_vote")
    template_name = "vote/vote.html"

    # pylint:disable=unused-argument
    def get(self, request, *args, **kwargs):
        context = {
            "is_vote_started": is_vote_started(),
            "is_vote_ended": is_vote_ended(),
            "vote_start": settings.VOTE_START.isoformat(),
            "vote_end": settings.VOTE_END.isoformat(),
            "form": VoteForm(),
        }

        cats = list(Submission.objects.all())
        shuffle(cats)
        context["cats"] = cats

        return render(request, self.template_name, context)

    # pylint:disable=unused-argument
    def post(self, request, *args, **kwargs):
        form = VoteForm(request.POST)
        if form.is_valid() and is_vote_started() and not is_vote_ended():
            submissions = Submission.objects.all()
            current_votes = Vote.objects.filter(voter=request.user).delete()
            vote = form.cleaned_data.get("choices").split(",")[1:]
            n = len(vote)
            for i in range(n):
                Vote(
                    voter=request.user,
                    submission=submissions.get(pk=vote[i]),
                    weight=(n - i),
                ).save()
            return redirect("vote:results")

        context = {
            "is_vote_started": is_vote_started(),
            "is_vote_ended": is_vote_ended(),
            "vote_start": settings.VOTE_START.isoformat(),
            "vote_end": settings.VOTE_END.isoformat(),
        }
        cats = list(Submission.objects.all())
        shuffle(cats)
        context["cats"] = cats
        context["form"] = VoteForm()
        return render(request, self.template_name, context)

catcdc/apps/vote/templates/vote/cats.html
{% extends "base.html" %}

{% load static %}

{% block head %}
<link rel="stylesheet" href="{% static "carousel.css" %}">
{% endblock %}

{% block content %}

<h3>Cats</h3>

<a href="{% url "vote:results" %}"><button>Results</button></a>

{% if is_submission_started and not is_submission_ended and perms.vote.add_submission and perms.vote.change_submission %}
    <br />
    <a href="{% url "vote:submission" %}"><button>Submit your cat</button></a>
{% elif is_vote_started and not is_vote_ended and perms.vote.add_vote and perms.vote.change_vote %}
    <br />
    <a href="{% url "vote:vote" %}"><button>Vote for the cutest cat</button></a>
{% endif %}

<table>
    <thead>
        <tr>
            <th>name</th>
            <th>description</th>
            <th>pictures</th>
            {% if is_vote_ended %}<th>owner</th>{% endif %}
        </tr>
    </thead>
    <tbody>
        {% for cat in cats %}
            <tr>
                <td>{{ cat.cat_name }}</td>
                <td>{{ cat.presentation }}</td>
                <td>
                    <div class="pic-ctn">
                        <img src="{{ cat.image_1.url }}" alt="">
                        <img src="{{ cat.image_2.url }}" alt="">
                        <img src="{{ cat.image_3.url }}" alt="">
                        <img src="{{ cat.image_4.url }}" alt="">
                        <img src="{{ cat.image_5.url }}" alt="">
                    </div>
                </td>
                {% if is_vote_ended %}<td>{{ cat.submitter.username }}</td>{% endif %}
            </tr>
        {% endfor %}
    </tbody>
</table>

{% endblock %}

catcdc/apps/vote/templates/vote/results.html
{% extends "base.html" %}

{% block head %}
<link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
{% endblock %}

{% block content %}

<h3>Results</h3>

<a href="{% url "vote:cats" %}"><button>Show me the cats!</button></a>

{% if is_submission_started and not is_submission_ended and perms.vote.add_submission and perms.vote.change_submission %}
    <br />
    <a href="{% url "vote:submission" %}"><button>Submit your cat</button></a>
{% elif is_vote_started and not is_vote_ended and perms.vote.add_vote and perms.vote.change_vote %}
    <br />
    <a href="{% url "vote:vote" %}"><button>Vote for the cutest cat</button></a>
{% endif %}

<p>Total number of registered votes: {{ total_nb_votes }}</p>

<table>
    <thead>
        <tr>
            <th>#</th>
            <th>cat</th>
            <th>score</th>
            <th>top vote</th>
            {% if is_vote_ended %}<th>owner</th>{% endif %}
        </tr>
    </thead>
    <tbody>
        {% for result in results %}
            <tr>
                <td>{{ forloop.counter }}</td>
                <td>
                    {{ result.0.cat_name }}
                    {% if forloop.counter <= 3 %}<i class="material-icons">star</i>{% endif %}
                    {% if forloop.counter <= 2 %}<i class="material-icons">star</i>{% endif %}
                    {% if forloop.counter <= 1 %}<i class="material-icons">star</i>{% endif %}
                    {% if forloop.counter == 42 %}<i class="material-icons">favorite</i>{% endif %}
                </td>
                <td>{{ result.1 }}</td>
                <td>{{ result.2 }}</td>
                {% if is_vote_ended %}<td>{{ result.0.submitter.username }}</td>{% endif %}
            </tr>
        {% endfor %}
    </tbody>
</table>

{% endblock %}

catcdc/apps/vote/templates/vote/submission.html
{% extends "base.html" %}

{% block content %}

<h3>Submit your cat!</h3>

<a href="{% url "vote:cats" %}"><button>Show me the cats!</button></a>
<br />
<a href="{% url "vote:results" %}"><button>Results</button></a>

{% if is_submission_ended %}
    <p>Submissions are over!</p>
{% elif is_submission_started %}
    <p>Submissions are now available. You still have time!</p>
    {% include "countdown.html" with end=submission_end %}

    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="Miaou">
    </form>
{% else %}
    <p>Submissions are not yet available. Come back in:</p>
    {% include "countdown.html" with end=submission_start %}
{% endif %}

{% endblock %}

catcdc/apps/vote/templates/vote/vote.html
{% extends "base.html" %}

{% load static %}

{% block content %}

<h3>Vote for the cutest cats</h3>

<a href="{% url "vote:cats" %}"><button>Show me the cats!</button></a>
<br />
<a href="{% url "vote:results" %}"><button>Results</button></a>

{% if is_vote_ended %}
    <p>Votes are over!</p>
{% elif is_vote_started %}
    <p>Votes are now available. You still have time!</p>
    {% include "countdown.html" with end=vote_end %}

    <table id="vote-choices">
        <thead>
            <tr>
                <th>name</th>
                <th>picture</th>
                <th></th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            {% for cat in cats %}
            <tr id="{{ cat.pk }}">
                <td>{{ cat.cat_name }}</td>
                <td><img style="height: 25px;" src="{{ cat.image_1.url }}" alt=""></td>
                <td><button class="arrow">⬆️</button></td>
                <td><button class="arrow">⬇️</button></td>
            </tr>
            {% endfor %}
        </tbody>
    </table>

    <script>
        window.$ = r => document.querySelector(r);
        window.$$ = r => document.querySelectorAll(r);

        function sibling(node, next) {
            if (!node) return;
            const name = node.nodeName;

            let sib = node;
            do {
                sib = next ? sib.nextSibling : sib.previousSibling;
            } while(sib && sib.nodeName !== name);

            return sib;
        }

        function insertAfter(container, node, ref) {
            return container.insertBefore(node, sibling(ref, true));
        }

        const rows = $$('#vote-choices > tbody > tr');

        rows.forEach(row => $$(`#\\3${row.id}  button`).forEach((buttonArrow, idB) => {
            buttonArrow.addEventListener('click', () => {
                const tr = buttonArrow.parentElement.parentElement;

                let sib = sibling(tr, idB !== 0);
                if (idB !== 0) {
                    sib = sibling(sib, true);
                }

                sib && tr.parentNode.insertBefore(tr, sib);
            });
        }));
    </script>

    <form id="form" method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <input id="submit" type="submit" value="Miaou">
    </form>

    <script>
        $('#submit').addEventListener('click', () => {
           const rows = $$('#vote-choices > tbody > tr');
           const hiddenField = $('#id_choices');
           hiddenField.value = '';

           rows.forEach(row => {
               hiddenField.value += ',' + row.id;
           });
        });
    </script>
{% else %}
    <p>Votes are not yet available. Come back in:</p>
    {% include "countdown.html" with end=vote_start %}
{% endif %}

{% endblock %}